/** @file led_demo.c
*   @brief led demo implementation File
*   @date 11.August.2009
*   @version 1.00.000
*
*   (c) Texas Instruments 2009, All rights reserved.
*/

#include "het.h"

/** @fn run_LED_StartUp(void)
*
*   This function is called during the start up, LED's are turned on
*   in a sequence to indicate the board is powerd up and ready to run
*   the demo software.
*
*/
void run_LED_StartUp(void)
{
  static int temp,delay;

  /** - Delay Parameter */
  delay = 0x200000;

  /** - NHET is configured as Master
   *  - NHET is turned On
   */
  hetREG1->GCR = 0x01000001;

  /** - PULL functinality is enabled */
  hetREG1->PULDIS  = 0x00000000;

  /** - This if statment is a placeholder for ArgoBoard/USBStick check */
  if(1)
  {
    /** - Configure NHET pins as output */
    hetREG1->DIR = 0xA8178035;
    /** - Turn all LEDs off */
    hetREG1->DOUT = 0x00110014;

    while(1)
    {
      /** - Set only NHET[0] */
      hetREG1->DOUT = 0x00110015;
      /** - Simple Dealy */
      for(temp=0;temp<delay;temp++);

      /** - Turn all LEDs off */
      hetREG1->DOUT  = 0x00110014;
      for(temp=0;temp<delay;temp++);
    }

  }
  else
  {
  }
}
